/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package entities;

import java.io.Serializable;
import javax.persistence.*;

/**
 *
 * @author Maeva
 */
@Entity
@NamedQueries({
    @NamedQuery(name = "AssociationChansonsPlaylists.findByChansonEtPlaylist", query = "SELECT a from AssociationChansonsPlaylists a where a.chanson_id=:chanson_id and a.playlist_id=:playlist_id"),
    @NamedQuery(name = "AssociationChansonsPlaylists.bougePositionChanson", query = "UPDATE AssociationChansonsPlaylists a set a.position_chanson_dans_playlist=:new_position where a.position_chanson_dans_playlist=:position"),
    @NamedQuery(name = "AssociationChansonsPlaylists.findPosition", query = "SELECT a.position_chanson_dans_playlist from AssociationChansonsPlaylists a where a.chanson_id=:chanson_id and a.playlist_id=:playlist_id"),
    @NamedQuery(name = "AssociationChansonsPlaylists.findNbChansonsDansPlaylist", query = "SELECT count(a) from AssociationChansonsPlaylists a where a.playlist_id=:playlist_id"),
    @NamedQuery(name = "AssociationChansonsPlaylists.bougePositionChansonVoulue", query = "UPDATE AssociationChansonsPlaylists a set a.position_chanson_dans_playlist=:new_position where a.chanson_id=:chanson_id and a.playlist_id=:playlist_id"),
    @NamedQuery(name = "AssociationChansonsPlaylists.supprimeChansonDansPlaylist", query = "DELETE from AssociationChansonsPlaylists a where a.chanson_id=:chanson_id and a.playlist_id=:playlist_id"),
    @NamedQuery(name = "AssociationChansonsPlaylists.supprimePlaylist", query = "DELETE from AssociationChansonsPlaylists a where a.playlist_id=:playlist_id")})
public class AssociationChansonsPlaylists implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    private Long chanson_id;
    @Id
    private Long playlist_id;
    @Column(name="position_chanson_dans_playlist")
    private int position_chanson_dans_playlist;
    
    @ManyToOne
  @PrimaryKeyJoinColumn(name="CHANSON_ID", referencedColumnName="CHANSON_ID")
  private Chanson chanson;
    
   @ManyToOne
  @PrimaryKeyJoinColumn(name="PLAYLIST_ID", referencedColumnName="PLAYLIST_ID")
  private Playlist playlist;

    public AssociationChansonsPlaylists() {
    }
    
    public AssociationChansonsPlaylists(Playlist p, Chanson c, int position) {
        this.chanson=c;
        this.chanson_id=c.getchanson_Id();
        this.playlist=p;
        this.playlist_id=p.getId();
        this.position_chanson_dans_playlist=position; //modif
    }
    public Long getChanson_id() {
        return chanson_id;
    }

    public void setChanson_id(Long chanson_id) {
        this.chanson_id = chanson_id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (chanson_id != null ? chanson_id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof AssociationChansonsPlaylists)) {
            return false;
        }
        AssociationChansonsPlaylists other = (AssociationChansonsPlaylists) object;
        if ((this.chanson_id == null && other.chanson_id != null) || (this.chanson_id != null && !this.chanson_id.equals(other.chanson_id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entities.AssociationChansonsPlaylists[ id=" + chanson_id + " ]";
    }

    public Long getPlaylist_id() {
        return playlist_id;
    }

    public void setPlaylist_id(Long playlist_id) {
        this.playlist_id = playlist_id;
    }

    public int getPosition_chanson_dans_playlist() {
        return position_chanson_dans_playlist;
    }

    public void setPosition_chanson_dans_playlist(int position_chanson_dans_playlist) {
        this.position_chanson_dans_playlist = position_chanson_dans_playlist;
    }

    public Chanson getChanson() {
        return chanson;
    }

    public void setChanson(Chanson chanson) {
        this.chanson = chanson;
    }

    public Playlist getPlaylist() {
        return playlist;
    }

    public void setPlaylist(Playlist playlist) {
        this.playlist = playlist;
    }
    
}
