/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package sessionbeans;

import entities.AssociationChansonsPlaylists;
import entities.Repertoire;
import java.util.List;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author Maeva
 */
@Stateless
@LocalBean
public class GestionnaireRepertoire {

     @PersistenceContext(unitName = "MusiqueANTOINE-MOPOLO-ejbPU")
    private EntityManager em;
     
    
    
    public void creerRepertoire(Repertoire r)
    {
        em.persist(r);
    }
    
    public void updateRepertoire(Repertoire r)
    {
        em.merge(r);
    }
    
    public Repertoire chercheParChemin(String chemin) {
        Query query = em.createNamedQuery("Repertoire.chercheParChemin");
        query.setParameter("chemin", chemin);
        Repertoire r = null;
        try {
            r = (Repertoire) query.getSingleResult();
        } catch (NoResultException e) {
            return null;
        }
        return r;
    }
    
    public List<Repertoire> chercheCeuxSansParent()
    {
        Query query = em.createNamedQuery("Repertoire.chercheCeuxSansParent");
        List<Repertoire> a=query.getResultList();
        return a;
        
    }
    
    public List<Repertoire> chercheFils(Repertoire r)
    {
        Query query = em.createNamedQuery("Repertoire.chercheFils");
        System.out.println("MON PARAM"+r.getRepertoire_nom());
        query.setParameter("idrep", r.getRepertoire_nom());
        List<Repertoire> a=query.getResultList();
        System.out.println("TAILLE LISTE"+a.size());
        return a;
        
    }
}
