/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package managedbeans;

import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import java.io.Serializable;
import entities.Chanson;
import entities.Album;
import entities.Commentaire;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import javax.ejb.EJB;
import org.primefaces.model.LazyDataModel;
import org.primefaces.model.SortOrder;
import sessionbeans.GestionnaireAlbum;


/**
 *
 * @author micro
 */
@Named(value = "albumMBean")
@SessionScoped
public class AlbumMBean implements Serializable {
    
    
     @EJB
    private GestionnaireAlbum gestionnaireAlbum;
    private Album album;
    private String genreSelectionne;
    private List<Album> listeAlbumsCateg;
    private String titre;
    
    private List<Album> listeAlbumsSearch;
    private List<Commentaire> listeCommentaires;
    private String cheminCouverture;
    private Chanson chansonSelectionne;
    //private LazyDataModel<Album> lazyModel;  
    
    /** Creates a new instance of AlbumMBean */
    public AlbumMBean() {
//        lazyModel = new LazyDataModel<Album>() {  
//  
//            @Override
//            public List<Album> load(int i, int i1, String string, SortOrder so, Map<String, String> map) {
//                System.out.println("ON MAPPELLE");
//                List<Album> maliste = gestionnaireAlbum.getAllAlbums(); 
//                System.out.println("MA LISTE A UNE TAILLE DE "+maliste.size());
//                return maliste;  
//            }
//        }    ;
    }
    
    /*
 * retourne tous les albums dans une liste
 */
    
    public List<Album> getAlbums()
    {
        return gestionnaireAlbum.getAllAlbums();
    }
    
    
     public List<Chanson> getAlbumChansons()
    {
        return gestionnaireAlbum.getAllAlbumChansons(getAlbum());
    }
    
    public Album getDetails() {
        return getAlbum();
    }
      
    public String showDetails(Album album) {
        this.setAlbum(album);
        return "albumDetails";
    }
    
    public String searchAllAlbums(String titre)
    {
        System.out.println(titre);
        this.setTitre('%'+titre+'%');
        System.out.println(this.getTitre());
        setListeAlbumsSearch(gestionnaireAlbum.searchAll(this.getTitre()));
        this.setTitre(titre);
        return "listSearchAlbums";
    }
    
    public String getAlbumsDUneCategorie(String genre)
    {
        this.setGenreSelectionne(genre);
        setListeAlbumsCateg(gestionnaireAlbum.getAlbumsDUneCategorie(genre));
        return "detailsCategorie";
    }

    public String getGenreSelectionne() {
        return genreSelectionne;
    }

    public void setGenreSelectionne(String genreSelectionne) {
        this.genreSelectionne = genreSelectionne;
    }

    public List<Album> getListeAlbumsCateg() {
        return listeAlbumsCateg;
    }

    public void setListeAlbumsCateg(List<Album> listeAlbumsCateg) {
        this.listeAlbumsCateg = listeAlbumsCateg;
    }

    public List<Album> getListeAlbumsSearch() {
        return listeAlbumsSearch;
    }

    public void setListeAlbumsSearch(List<Album> listeAlbumsSearch) {
        this.listeAlbumsSearch = listeAlbumsSearch;
    }

    public String getTitre() {
        return titre;
    }

    public void setTitre(String titre) {
        this.titre = titre;
    }

    public List<Commentaire> getListeCommentaires() {
        this.listeCommentaires = gestionnaireAlbum.getCommentairesDUnAlbum(getAlbum());
        return listeCommentaires;
    }

    public void setListeCommentaires(List<Commentaire> listeCommentaires) {
        this.listeCommentaires = listeCommentaires;
    }

    public String getCheminCouverture() {
        System.out.println("MON CHEMIN="+getAlbum().getAlbum_repertoire().getRepertoire_chemin()+"\\"+getAlbum().getAlbum_couverture());
        cheminCouverture= getAlbum().getAlbum_repertoire().getRepertoire_chemin()+"\\"+getAlbum().getAlbum_couverture();
        return cheminCouverture;
    }

    public void setCheminCouverture(String cheminCouverture) {
        this.cheminCouverture = cheminCouverture;
    }
    public Chanson getChansonSelectionne() {
        return chansonSelectionne;
    }

    public void setChansonSelectionne(Chanson chansonSelectionne) {
        this.chansonSelectionne = chansonSelectionne;
    }

    public void setAlbum(Album album) {
        this.album = album;
    }

    public Album getAlbum() {
        return album;
    }

//    public LazyDataModel<Album> getLazyModel() {
//     lazyModel = new LazyAlbumDataModel(getAlbums());
//     return lazyModel;
//    }
//
//    public void setLazyModel(LazyDataModel<Album> lazyModel) {
//        this.lazyModel = lazyModel;
//    }
    
    
    
}
