/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package managedbeans;

import entities.Album;
import entities.Artiste;
import entities.AssociationChansonsPlaylists;
import entities.Chanson;
import entities.Playlist;
import java.util.List;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import sessionbeans.GestionnairePlaylist;
import java.io.Serializable;
import sessionbeans.GestionnaireAlbum;

/**
 *
 * @author Maeva
 */
@Named(value = "playlistMBean")
@SessionScoped
public class PlaylistMBean implements Serializable {

    @EJB
    GestionnairePlaylist gestionnairePlaylist;
    GestionnaireAlbum gestionnairealbum;
    private Playlist playlist;
    private int nbchansons;
    private List<AssociationChansonsPlaylists> chansonsPlaylist;
    private long playlistId;
    private Album album;
    /**
     * Creates a new instance of PlaylistMBean
     */
    public PlaylistMBean() {
    }
    

    public Playlist getPlaylist() {
        return playlist;
    }

    public void setPlaylist(Playlist playlist) {
        this.playlist = playlist;
    }
    
    
    public long getPlaylistId() {
        return playlistId;
    }

    public void setPlaylistId(long playlistId) {
        this.playlistId = playlistId;
    }
    
    public Playlist getDetails() {
        return playlist;
    }
    
    public int nbchansonsdansplaylist(Playlist p)
    {
        nbchansons = gestionnairePlaylist.getNbChansonsDansPlaylist(p);
        return nbchansons;
    }
    
    public String showDetails(Playlist playlist) {
        this.playlist = playlist;
        return "detailsPlaylist";
    }
    
    public void supprimeChansonDansPlaylist(Chanson c)
    {
        gestionnairePlaylist.supprimeChansonDansPlaylist(playlist, c);
    }
    
    public void supprimePlaylist(Playlist pl)
    {
        gestionnairePlaylist.supprimePlaylist(pl);
    }
    
    public void bougeChanson(Chanson c, int position, String action)
    {
        gestionnairePlaylist.bougeChanson(playlist, c, position, action);
    }

    public List<AssociationChansonsPlaylists> getChansonsPlaylist() {
        chansonsPlaylist = gestionnairePlaylist.getChansonsPlaylist(playlist);
        return gestionnairePlaylist.getChansonsPlaylist(playlist);
    }

    public void setChansonsPlaylist(List<AssociationChansonsPlaylists> chansonsPlaylist) {
        this.chansonsPlaylist = chansonsPlaylist;
    }
    
    
    
    public void addChanson(Chanson c)
    {
       this.playlist=gestionnairePlaylist.findPlaylist(this.playlistId);
       System.out.println("J'ajoute la chanson"+playlist.getPlaylist_nom()+" "+c.getChanson_titre());
       gestionnairePlaylist.addChanson(playlist,c);
    }
    
    public void addAlbum(Album a)
    {
       this.album=gestionnairealbum.chercheParTitre(a.getAlbum_titre());
       //System.out.println(playlist.getPlaylist_nom()+" "+album.getAlbum_titre()+" "+album.getAlbum_chansons().size());
       for(int i=0;i<album.getAlbum_chansons().size();i++){
           gestionnairePlaylist.addChanson(playlist,album.getAlbum_chansons().get(i));
       }
       
    }
    
    public void addArtiste(Playlist p, Artiste a)
    {
       System.out.println(p.getPlaylist_nom()+" "+a.getArtiste_nom()+" "+a.getArtiste_chansons().size());
       for(int i=0;i<a.getArtiste_chansons().size();i++){
           gestionnairePlaylist.addChanson(p,a.getArtiste_chansons().get(i));
       }
    }

    public int getNbchansons() {
        return nbchansons;
    }

    public void setNbchansons(int nbchansons) {
        this.nbchansons = nbchansons;
    }
}
