/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package managedbeans;

import entities.Album;
import entities.Chanson;
import entities.Commentaire;
import entities.Repertoire;
import java.io.Serializable;
import java.util.List;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.Dependent;
import javax.enterprise.context.SessionScoped;
import sessionbeans.GestionnaireAlbum;
import sessionbeans.GestionnaireRepertoire;

/**
 *
 * @author Maeva
 */
@Named(value = "repertoireMBean")
@SessionScoped
public class RepertoireMBean implements Serializable{

    @EJB
    GestionnaireRepertoire gestionnaireRepertoire;
    @EJB
    GestionnaireAlbum gestionnaireAlbum;
    private Repertoire repertoire_courant;
    private List<Repertoire> repertoiresFils;
    private List<Repertoire> premiersRepertoires;
    private Album albumcourant;
    private List<Commentaire> listeCommentaires;
    
    /**
     * Creates a new instance of RepertoireMBean
     */
    public RepertoireMBean() {
    }

   
    
    public List<Repertoire> getRepertoiresFils() {
        return repertoiresFils;
    }
    
    public String detailsPere(Repertoire r)
    {
        repertoiresFils = gestionnaireRepertoire.chercheFils(r);
        if(repertoiresFils.size()==0)
        {
            albumcourant=gestionnaireAlbum.chercheParRep(r);
            return "detailsAlbumRep";
        }
        else
        {
        return "detailsRep";
        }
    }
    
     public List<Chanson> getAlbumChansons()
    {
        return gestionnaireAlbum.getAllAlbumChansons(albumcourant);
    }
    
    public void setRepertoiresFils(List<Repertoire> repertoiresFils) {
        this.repertoiresFils = repertoiresFils;
    }

    public Repertoire getRepertoire_courant() {
        return repertoire_courant;
    }

    public void setRepertoire_courant(Repertoire repertoire_courant) {
        this.repertoire_courant = repertoire_courant;
    }

    public List<Repertoire> getPremiersRepertoires() {
        premiersRepertoires=gestionnaireRepertoire.chercheCeuxSansParent();
        return premiersRepertoires;
    }

    public void setPremiersRepertoires(List<Repertoire> premiersRepertoires) {
        this.premiersRepertoires = premiersRepertoires;
    }

    public Album getAlbumcourant() {
        System.out.println("JE RENVOIE LALBUM COURANT "+albumcourant.getAlbum_titre());
        return albumcourant;
    }

    public void setAlbumcourant(Album albumcourant) {
        this.albumcourant = albumcourant;
    }

    public List<Commentaire> getListeCommentaires() {
       this.listeCommentaires = gestionnaireAlbum.getCommentairesDUnAlbum(albumcourant);
        return listeCommentaires;
    }

    public void setListeCommentaires(List<Commentaire> listeCommentaires) {
        this.listeCommentaires = listeCommentaires;
    }

}
