/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package sessionbeans;

import entities.Chanson;
import java.util.Collection;
import java.util.List;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author Maeva
 */
@Stateless
@LocalBean
public class GestionnaireChanson {

 @PersistenceContext(unitName = "MusiqueANTOINE-MOPOLO-ejbPU")
    private EntityManager em;
 
 
    
    public void creerChanson(Chanson c)
    {
        em.persist(c);
    }
    
    public List<String> chercheToutesCategories() {
        Query query = em.createNamedQuery("Chanson.chercheToutesCategories");
        return query.getResultList();
    }
    
     public List<Chanson> searchAll(String titrechanson) {
        Query query = em.createNamedQuery("Chanson.searchAll");
        query.setParameter("titreChanson", titrechanson);
        return query.getResultList();
    }
    
    public List<Chanson> getChansonsDUneCategorie(String genre)
    {
        Query query = em.createNamedQuery("Chanson.listeChansonsDUneCategorie");
        query.setParameter("genre", genre);
        return query.getResultList();
    }
    
    public List<Chanson> getAllChansons()
    {
        Query query = em.createNamedQuery("Chanson.findAll");
        return query.getResultList();
    }
}
