/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package sessionbeans;

import entities.Album;
import entities.Commentaire;
import entities.Utilisateur;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author Maeva
 */
@Stateless
@LocalBean
public class GestionnaireCommentaire {

     @PersistenceContext(unitName = "MusiqueANTOINE-MOPOLO-ejbPU")
    private EntityManager em;
     
  
     
     public void creerCommentaire(Commentaire c)
     {
         em.persist(c);
     }
     
     public Commentaire getCommentaireUserPourAlbum(Album a, Utilisateur u) {
        Query q = em.createNamedQuery("Commentaire.commentaireUserPourAlbum");
        q.setParameter("album", a);
        q.setParameter("user", u);
        try{
            Commentaire com = (Commentaire) q.getSingleResult();
            return com;
        }
        catch(NoResultException e) // s'il n'y a aucun résultat
        {
            return null;
        }
    }
    
}
