/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package sessionbeans;

import entities.Utilisateur;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author Maeva
 */
@Stateless
@LocalBean
public class GestionnaireUtilisateur {

    @PersistenceContext(unitName = "MusiqueANTOINE-MOPOLO-ejbPU")
    private EntityManager em;
     
    public void creerUtilisateur(Utilisateur u)
    {
        em.persist(u);
    }
    
    public void updateUtilisateur(Utilisateur u)
    {
        em.merge(u);
    }
    
    public Utilisateur getUserByEmail(String email)
    {
        Query query = em.createNamedQuery("Utilisateur.connexion");
        query.setParameter("email", email);
        Utilisateur u = null;
        try {
            u = (Utilisateur) query.getSingleResult();
        } catch (NoResultException e) {
            return null;
        }
        return u;
    }
    
}
