/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package managedbeans;

import entities.Artiste;
import entities.Album;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import java.io.Serializable;
import java.util.List;
import javax.ejb.EJB;
import sessionbeans.GestionnaireArtiste;

/**
 *
 * @author Maeva
 */
@Named(value = "artisteMBean")
@SessionScoped
public class ArtisteMBean implements Serializable {
    @EJB
    private GestionnaireArtiste gestionnaireArtiste;
    private Artiste artiste;

    /**
     * Creates a new instance of ArtisteMBean
     */
    public ArtisteMBean() {
    }
    
    public List<Artiste> getArtistes()
    {
        return gestionnaireArtiste.getAllArtistes();
    }
    
     public List<Album> getArtisteAlbums()
    {
        return gestionnaireArtiste.getAllArtisteAlbums(artiste);
    }  
    
    public Artiste getDetails() {
        return artiste;
    }
    
    public String showDetails(Artiste artiste) {
        this.artiste = artiste;
        return "artisteDetails";
    }
}
