/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
package managedbeans;

import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import java.io.Serializable;
import java.util.List;
import javax.ejb.EJB;
import sessionbeans.GestionnaireChanson;
import entities.Chanson;

/**
 *
 * @author Maeva
 */
@Named(value = "chansonMBean")
@SessionScoped
public class ChansonMBean implements Serializable {
    @EJB
    private GestionnaireChanson gestionnaireChanson;
    private Chanson chanson;
    private List<Chanson> listeChansonsCateg;
    private String genreSelectionne;
    private String titreChanson;
    private List<Chanson> listChansonSearch;
 
    /**
     * Creates a new instance of ChansonMBean
     */
    public ChansonMBean() {
    }
    
    public Chanson getDetails() {
        return chanson;
    }
    
    public List<Chanson> getChansons()
    {
        return gestionnaireChanson.getAllChansons();
    }
       
    
    public List<String> getAllCategories()
    {
        return gestionnaireChanson.chercheToutesCategories();
    }
    
    public String searchAllChansons(String titre)
    {
        System.out.println(titre);
        this.setTitreChanson('%'+titre+'%');
        System.out.println(this.getTitreChanson());
        setListChansonSearch(gestionnaireChanson.searchAll(this.getTitreChanson()));
        this.setTitreChanson(titre);
        return "listSearchChansons";
    }
    
    public String getChansonsDUneCategorie(String genre)
    {
        this.genreSelectionne=genre;
        setListeChansonsCateg(gestionnaireChanson.getChansonsDUneCategorie(genre));
        return "detailsCategorie";
    }

    public List<Chanson> getListeChansonsCateg() {
        return listeChansonsCateg;
    }

    public void setListeChansonsCateg(List<Chanson> listeChansonsCateg) {
        this.listeChansonsCateg = listeChansonsCateg;
    }

    public String getGenreSelectionne() {
        return genreSelectionne;
    }

    public void setGenreSelectionne(String genreSelectionne) {
        this.genreSelectionne = genreSelectionne;
    }

    public List<Chanson> getListChansonSearch() {
        return listChansonSearch;
    }

    public void setListChansonSearch(List<Chanson> listChansonSearch) {
        this.listChansonSearch = listChansonSearch;
    }

    public String getTitreChanson() {
        return titreChanson;
    }

    public void setTitreChanson(String titreChanson) {
        this.titreChanson = titreChanson;
    }
    
}
